;
; TEXTCON setzt die Textbits zum Anzeigen

textcon:
	ldi		yl,low(textkopie)
	ldi		yh,high(textkopie)
; Poti U1   textkopie 0,1
	ld		r3,y+
	ld		r4,y+
	lds		acc2,sollu1
	lds		acc3,sollu1+1
	rcall	vergleich0
	sbrc	acc,0
	sbr		vartext,(1<<0)
; Poti U2   textkopie 2,3
	ld		r3,y+
	ld		r4,y+
	lds		acc2,sollu2
	lds		acc3,sollu2+1
	rcall	vergleich0
	sbrs	acc,0
	sbr		vartext,(1<<1)
; Poti i1   textkopie 4,5
	ld		r3,y+
	ld		r4,y+
	lds		acc2,solli1
	lds		acc3,solli1+1
	rcall	vergleich0
	sbrc	acc,0
	sbr		vartext,(1<<2)
; Poti i2   textkopie 6,7
	ld		r3,y+
	ld		r4,y+
	lds		acc2,solli2
	lds		acc3,solli2+1
	rcall	vergleich0
	sbrc	acc,0
	sbr		vartext,(1<<3)
; Sollwerte P und I vom Leistungsschalter textkopie 8,9 und 10,11
	ld		r3,y+
	ld		r4,y+
	lds		acc2,leistungsstufe
	clr		acc3
	rcall	vergleich0
	sbrc	acc,0
	sbr		vartext,(1<<4)
; gemessene und ausgerechnete Werte anzeigen
	ld		r3,y+
	ld		r4,y+
	lds		acc2,istu
	lds		acc3,istu+1
	rcall	vergleich1
	sbrc	acc,0
	rjmp	txtc2
	
	ld		r3,y+
	ld		r4,y+
	lds		acc2,isti
	lds		acc3,isti+1
	rcall	vergleich1
	sbrs	acc,0
	rjmp	txtc3
txtc2:
	sbr		vartext,(1<<6)
	sbr		vartext,(1<<5)
txtc3:
; Temperatur    textkopie 12,13
	ld		r3,y+
	ld		r4,y+
	lds		acc2,temperatur
	lds		acc3,temperatur+1
	rcall	vergleich0
	sbrc	acc,0
	sbr		vartext,(1<<7)
; Reglermod u oder I anzeigen	14,15
	ld		r3,y+
	ld		r4,y+
	lds		acc2,inbytec
	andi	acc2,0b00100000
	clr		acc3
	rcall	vergleich0
	sbrs	acc,0
	rjmp	txtc5
	sbr		merker1,(1<<uanzeigen)
	sbr		merker1,(1<<ianzeigen)
txtc5:
; Meldungen
	lds		acc,meldungen
	tst		acc
	brne	txtc6
	ret
txtc6:
	cbr		vartext,(1<<5)
	cbr		vartext,(1<<6)
;	cbr		vartext,(1<<7)
    ldi     acc,0xff
    sts     textkopie+10,acc
    sts     textkopie+11,acc
;    sts     textkopie+12,acc
;    sts     textkopie+13,acc
    sts     textkopie+14,acc
    sts     textkopie+15,acc
	sbr		merker1,(1<<mldanzeigen)
	ret
		
; ------ UPs --------------

vergleich0:
	cp		acc3,r4
	cpc		acc2,r3
	breq	vgl1
	dec		yl	
	dec		yl
	st		y+,acc2
	st		y+,acc3
	ldi		acc,1		; ist gendert worden
	ret
vgl1:
	clr		acc
	ret	

vergleich1:
	sub		r4,acc3
	sbc		r3,acc2
	breq	vgl11		; identisch
	ldi		acc4,1
	add		r4,acc4
	clr		acc4
	adc		r3,acc4		; 0..2?
	tst		r3
	brne	vgl12		; zu gro!
	mov		acc4,r4
	cpi		acc4,3
	brcc	vgl12		; zu gro!
vgl11:
	clr		acc			; identisch
	ret
vgl12:
	dec		yl	
	dec		yl
	st		y+,acc2
	st		y+,acc3
	ldi		acc,1		 ; ist gendert worden		
	ret
